/*
Check various cases of widget pool usage:
0. widget pool name:
- constant
- unknown var
- OK var
- 

1. CREATE WIDGET-POOL statement:
- multiple create in a row
- colliding name

2. DELETE WIDGET-POOL statement:
- multiple delete in a row
- missing widget-pool
- widget pool from other scope
- widget pool from current scope

3. named widget pools

4. unnamed widget pools

5. persistent widget pools

6. scoped to:
- external program
- procedure
- function

7. CREATE statement
- unnamed pool active above current scope

8. RUN statement
- persistent
- non-persistent

=============
preprocess vars:
create - yes/no to create the pool
cpool - pool name.
persist - mark this pool as persistent
creares - yes/no to create the resource
h - the handle were to save the resource
hpool - the named pool where to save the resource
dpool - pool name
delete - yes/no to delete the pool
*/

if {&create} then
   create widget-pool {&cpool} {&persist}.

if {&creares} then
   create button {&h} {&hpool}.

if {&delete} then
   delete widget-pool {&dpool}.