/*
Tests the following:
- unnamed pool, non-persistent
- create pool existing
- delete pool in a row
- scoped to proc/function
- check if widget survives after proc/function pool
- check if widget is deleted if pool deleted after proc/function pool
*/
{widget_pool_test.i}
{widget_pool_vars.i}

procedure proc0.
   def input param l as log.
   def input param l2 as log.

   {widget_pool.i
      &create  = "no" 
      &cpool   = " " 
      &persist = " "
      &creares = "no" 
      &h       = "h2" 
      &hpool   = " " 
      &delete  = "yes" 
      &dpool   = " "}

   /* h1 must be good at this time */
   checkRes(101, "h1", h1, no, no).
   
   h2=?.
   checkRes(102, "h2", h2, yes, yes).
   
   {widget_pool.i
      &create  = "yes" 
      &cpool   = " " 
      &persist = " "
      &creares = "yes" 
      &h       = "h2" 
      &hpool   = " " 
      &delete  = "no" 
      &dpool   = " "}
   checkRes(103, "h2", h2, no, no).
   
   {widget_pool.i
      &create  = "yes" 
      &cpool   = " " 
      &persist = " "
      &creares = "no" 
      &h       = "h2" 
      &hpool   = " " 
      &delete  = "no" 
      &dpool   = " "}
   checkRes(104, "h2", h2, no, no).
   
   if l then do:
      {widget_pool.i
         &create  = "no" 
         &cpool   = " " 
         &persist = " "
         &creares = "no" 
         &h       = "h2" 
         &hpool   = " " 
         &delete  = "yes" 
         &dpool   = " "}
      checkRes(105, "h2", h2, no, no).
   end.
   if l2 then do:
      {widget_pool.i
         &create  = "no" 
         &cpool   = " " 
         &persist = " "
         &creares = "no" 
         &h       = "h2" 
         &hpool   = " " 
         &delete  = "yes" 
         &dpool   = " "}
      checkRes(106, "h2", h2, yes, no).
   end.
end.

function func0 returns int(input l as log, input l2 as log).
   {widget_pool.i
      &create  = "no" 
      &cpool   = " " 
      &persist = " "
      &creares = "no" 
      &h       = "h3" 
      &hpool   = " " 
      &delete  = "yes" 
      &dpool   = " "}

   /* h1 must be good at this time */
   checkRes(101, "h1", h1, no, no).
   
   h3=?.
   checkRes(102, "h3", h3, yes, yes).
   
   {widget_pool.i
      &create  = "yes" 
      &cpool   = " " 
      &persist = " "
      &creares = "yes" 
      &h       = "h3" 
      &hpool   = " " 
      &delete  = "no" 
      &dpool   = " "}
   checkRes(103, "h3", h3, no, no).
   
   {widget_pool.i
      &create  = "yes" 
      &cpool   = " " 
      &persist = " "
      &creares = "no" 
      &h       = "h3" 
      &hpool   = " " 
      &delete  = "no" 
      &dpool   = " "}
   checkRes(104, "h3", h3, no, no).
   
   if l then do:
      {widget_pool.i
         &create  = "no" 
         &cpool   = " " 
         &persist = " "
         &creares = "no" 
         &h       = "h3" 
         &hpool   = " " 
         &delete  = "yes" 
         &dpool   = " "}
      checkRes(105, "h3", h3, no, no).
   end.
   if l2 then do:
      {widget_pool.i
         &create  = "no" 
         &cpool   = " " 
         &persist = " "
         &creares = "no" 
         &h       = "h3" 
         &hpool   = " " 
         &delete  = "yes" 
         &dpool   = " "}
      checkRes(106, "h3", h3, yes, no).
   end.
end.

{widget_pool.i
   &create  = "no" 
   &cpool   = " " 
   &persist = " "
   &creares = "no" 
   &h       = "h1" 
   &hpool   = " " 
   &delete  = "yes" 
   &dpool   = " "}

h1=?.
checkRes(1, "h1", h1, yes, yes).

{widget_pool.i
   &create  = "yes" 
   &cpool   = " " 
   &persist = " "
   &creares = "yes" 
   &h       = "h1" 
   &hpool   = " " 
   &delete  = "no" 
   &dpool   = " "}
checkRes(2, "h1", h1, no, no).

{widget_pool.i
   &create  = "yes" 
   &cpool   = " " 
   &persist = " "
   &creares = "no" 
   &h       = "h1" 
   &hpool   = " " 
   &delete  = "no" 
   &dpool   = " "}
checkRes(3, "h1", h1, no, no).

{widget_pool.i
   &create  = "no" 
   &cpool   = " " 
   &persist = " "
   &creares = "no" 
   &h       = "h1" 
   &hpool   = " " 
   &delete  = "yes" 
   &dpool   = " "}
checkRes(4, "h1", h1, no, no).

{widget_pool.i
   &create  = "no" 
   &cpool   = " " 
   &persist = " "
   &creares = "no" 
   &h       = "h1" 
   &hpool   = " " 
   &delete  = "yes" 
   &dpool   = " "}
checkRes(5, "h1", h1, yes, no).

/* recreate to check how pooled h1 is affected by pools in lower scopes */
h1=?.
{widget_pool.i
   &create  = "yes" 
   &cpool   = " " 
   &persist = " "
   &creares = "yes" 
   &h       = "h1" 
   &hpool   = " " 
   &delete  = "no" 
   &dpool   = " "}
checkRes(6, "h1", h1, no, no).

run proc0(no, no).
checkRes(7, "h2", h2, yes, no).
run proc0(yes, no).
checkRes(8, "h2", h2, yes, no).
run proc0(yes, yes).
checkRes(9, "h2", h2, yes, no).

func0(no, no).
checkRes(10, "h3", h3, yes, no).
func0(yes, no).
checkRes(11, "h3", h3, yes, no).
func0(yes, yes).
checkRes(12, "h3", h3, yes, no).

checkRes(13, "h1", h1, no, no).

/* re-delete the pool it to check if H1 can still be deleted */
{widget_pool.i
   &create  = "no" 
   &cpool   = " " 
   &persist = " "
   &creares = "no" 
   &h       = "h1" 
   &hpool   = " " 
   &delete  = "yes" 
   &dpool   = " "}
checkRes(14, "h1", h1, yes, no).
