/*
!!! RUN FROM A DEDICATED SESSION!!!

Tests the following:
- unnamed pool, persistent
- create pool non-existing
- delete pool existing
- delete pool in a row
- scoped to proc/function
- check if widget survives after proc/function pool
- check if widget is deleted if pool deleted after proc/function pool
*/
{widget_pool_test.i}
{widget_pool_vars.i}

procedure proc0.
   def input param l as log.

   h2=?.
   checkRes(101, "h2", h2, yes, yes).
   
   {widget_pool.i
      &create  = "yes" 
      &cpool   = " " 
      &persist = "persistent"
      &creares = "yes" 
      &h       = "h2" 
      &hpool   = " " 
      &delete  = "no" 
      &dpool   = " "}
   checkRes(102, "h2", h2, no, no).
   
   if l then do:
      {widget_pool.i
         &create  = "no" 
         &cpool   = " " 
         &persist = " "
         &creares = "no" 
         &h       = "h2" 
         &hpool   = " " 
         &delete  = "yes" 
         &dpool   = " "}
      checkRes(103, "h2", h2, no, no).
   end.
end.

function func0 returns int(input l as log).
   h3=?.
   checkRes(201, "h3", h3, yes, yes).
   
   {widget_pool.i
      &create  = "yes" 
      &cpool   = " " 
      &persist = "persistent"
      &creares = "yes" 
      &h       = "h3" 
      &hpool   = " " 
      &delete  = "no" 
      &dpool   = " "}
   checkRes(202, "h3", h3, no, no).
   
   if l then do:
      {widget_pool.i
         &create  = "no" 
         &cpool   = " " 
         &persist = " "
         &creares = "no" 
         &h       = "h3" 
         &hpool   = " " 
         &delete  = "yes" 
         &dpool   = " "}
      checkRes(203, "h3", h3, no, no).
   end.
end.

h1=?.
checkRes(1, "h1", h1, yes, yes).

{widget_pool.i
   &create  = "yes" 
   &cpool   = " " 
   &persist = "persistent"
   &creares = "yes" 
   &h       = "h1" 
   &hpool   = " " 
   &delete  = "no" 
   &dpool   = " "}
checkRes(2, "h1", h1, no, no).

{widget_pool.i
   &create  = "no" 
   &cpool   = " " 
   &persist = " "
   &creares = "no" 
   &h       = "h1" 
   &hpool   = " " 
   &delete  = "yes" 
   &dpool   = " "}
checkRes(3, "h1", h1, no, no).

/* recreate to check how pooled h1 is affected by pools in lower scopes */
h1=?.
{widget_pool.i
   &create  = "yes" 
   &cpool   = " " 
   &persist = " "
   &creares = "yes" 
   &h       = "h1" 
   &hpool   = " " 
   &delete  = "no" 
   &dpool   = " "}
checkRes(4, "h1", h1, no, no).

run proc0(no).
checkRes(5, "h2", h2, no, no).
run proc0(yes).
checkRes(6, "h2", h2, no, no).

func0(no).
checkRes(7, "h3", h3, no, no).
func0(yes).
checkRes(8, "h3", h3, no, no).

checkRes(9, "h1", h1, no, no).

{widget_pool.i
   &create  = "no" 
   &cpool   = " " 
   &persist = " "
   &creares = "no" 
   &h       = "h1" 
   &hpool   = " " 
   &delete  = "yes" 
   &dpool   = " "}
checkRes(10, "h1", h1, no, no).
checkRes(11, "h2", h2, no, no).
checkRes(12, "h3", h3, no, no).

{widget_pool.i
   &create  = "no" 
   &cpool   = " " 
   &persist = " "
   &creares = "no" 
   &h       = "h1" 
   &hpool   = " " 
   &delete  = "yes" 
   &dpool   = " "}
checkRes(10, "h1", h1, no, no).
checkRes(11, "h2", h2, no, no).
checkRes(12, "h3", h3, no, no).
