/*
Tests the following:
- named pool, non-persistent
- create pool non-existing
- delete pool existing
- scoped to proc/function
- check if widget survives after proc/function pool
- check if widget is deleted if pool deleted after proc/function pool
*/
{widget_pool_test.i}
{widget_pool_vars.i}

def var wp2a as char init "wp2a".

procedure proc0.
   def input param l as log.

   h2=?.
   checkRes(101, "h2", h2, yes, yes).
   
   {widget_pool.i
      &create  = "yes" 
      &cpool   = "wp2a" 
      &persist = "persistent"
      &creares = "yes" 
      &h       = "h2" 
      &hpool   = "in widget-pool wp2a" 
      &delete  = "no" 
      &dpool   = " "}
   checkRes(102, "h2", h2, no, no).
   
   if l then do:
      {widget_pool.i
         &create  = "no" 
         &cpool   = " " 
         &persist = " "
         &creares = "no" 
         &h       = "h2" 
         &hpool   = " " 
         &delete  = "yes" 
         &dpool   = "wp2a"}
      checkRes(103, "h2", h2, yes, no).
   end.
end.

function func0 returns int(input l as log).
   h3=?.
   checkRes(21, "h3", h3, yes, yes).
   
   {widget_pool.i
      &create  = "yes" 
      &cpool   = "wp2a" 
      &persist = "persistent"
      &creares = "yes" 
      &h       = "h3" 
      &hpool   = "in widget-pool wp2a" 
      &delete  = "no" 
      &dpool   = " "}
   checkRes(22, "h3", h3, no, no).
   
   if l then do:
      {widget_pool.i
         &create  = "no" 
         &cpool   = " " 
         &persist = " "
         &creares = "no" 
         &h       = "h3" 
         &hpool   = " " 
         &delete  = "yes" 
         &dpool   = "wp2a"}
      checkRes(23, "h3", h3, yes, no).
   end.
end.

h1=?.
checkRes(1, "h1", h1, yes, yes).

{widget_pool.i
   &create  = "yes" 
   &cpool   = "wp2a" 
   &persist = "persistent"
   &creares = "yes" 
   &h       = "h1" 
   &hpool   = "in widget-pool wp2a" 
   &delete  = "no" 
   &dpool   = " "}
checkRes(2, "h1", h1, no, no).

{widget_pool.i
   &create  = "no" 
   &cpool   = " " 
   &persist = "persistent"
   &creares = "no" 
   &h       = "h1" 
   &hpool   = " " 
   &delete  = "yes" 
   &dpool   = "wp2a"}
checkRes(3, "h1", h1, yes, no).


run proc0(no).
checkRes(5, "h2", h2, no, no).
delete widget-pool wp2a.
checkRes(6, "h2", h2, yes, no).
run proc0(yes).
checkRes(7, "h2", h2, yes, no).

func0(no).
checkRes(8, "h3", h3, no, no).
delete widget-pool wp2a.
checkRes(9, "h3", h3, yes, no).
func0(yes).
checkRes(10, "h3", h3, yes, no).
